# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PipelinescheduledrunsPipelineScheduledRunIdBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'exec_type': 'str',
        'exec_cron': 'str',
        'exec_period_start': 'date',
        'exec_period_end': 'date'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'exec_type': 'exec_type',
        'exec_cron': 'exec_cron',
        'exec_period_start': 'exec_period_start',
        'exec_period_end': 'exec_period_end'
    }

    def __init__(self, name=None, description=None, exec_type=None, exec_cron=None, exec_period_start=None, exec_period_end=None):  # noqa: E501
        """PipelinescheduledrunsPipelineScheduledRunIdBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._exec_type = None
        self._exec_cron = None
        self._exec_period_start = None
        self._exec_period_end = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if exec_type is not None:
            self.exec_type = exec_type
        if exec_cron is not None:
            self.exec_cron = exec_cron
        if exec_period_start is not None:
            self.exec_period_start = exec_period_start
        if exec_period_end is not None:
            self.exec_period_end = exec_period_end

    @property
    def name(self):
        """Gets the name of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The name of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param name: The name of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The description of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param description: The description of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def exec_type(self):
        """Gets the exec_type of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The exec_type of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: str
        """
        return self._exec_type

    @exec_type.setter
    def exec_type(self, exec_type):
        """Sets the exec_type of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param exec_type: The exec_type of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["manual", "recurring"]  # noqa: E501
        if exec_type not in allowed_values:
            raise ValueError(
                "Invalid value for `exec_type` ({0}), must be one of {1}"  # noqa: E501
                .format(exec_type, allowed_values)
            )

        self._exec_type = exec_type

    @property
    def exec_cron(self):
        """Gets the exec_cron of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The exec_cron of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: str
        """
        return self._exec_cron

    @exec_cron.setter
    def exec_cron(self, exec_cron):
        """Sets the exec_cron of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param exec_cron: The exec_cron of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: str
        """

        self._exec_cron = exec_cron

    @property
    def exec_period_start(self):
        """Gets the exec_period_start of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The exec_period_start of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: date
        """
        return self._exec_period_start

    @exec_period_start.setter
    def exec_period_start(self, exec_period_start):
        """Sets the exec_period_start of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param exec_period_start: The exec_period_start of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: date
        """

        self._exec_period_start = exec_period_start

    @property
    def exec_period_end(self):
        """Gets the exec_period_end of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501


        :return: The exec_period_end of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :rtype: date
        """
        return self._exec_period_end

    @exec_period_end.setter
    def exec_period_end(self, exec_period_end):
        """Sets the exec_period_end of this PipelinescheduledrunsPipelineScheduledRunIdBody.


        :param exec_period_end: The exec_period_end of this PipelinescheduledrunsPipelineScheduledRunIdBody.  # noqa: E501
        :type: date
        """

        self._exec_period_end = exec_period_end

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PipelinescheduledrunsPipelineScheduledRunIdBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelinescheduledrunsPipelineScheduledRunIdBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
